#include <malloc.h>
#include <string.h>
#include <math.h>


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#ifndef _WIN32
#include "ext/standard/info.h"
#endif//_WIN32
#include "euroValue.h"


//Up to 10^20:
//Should be the same as pow(10, 20)
static ULONGLONG POWERS[] = { 1L, 10L, 100L, 1E3, 1E4, 1E5, 1E6, 1E7, 1E8,
	1E9L, 1E10L, 1E11L, 1E12, 1E13, 1E14, 1E15, 1E16, 1E17, 1E18, 1E19
};

#define MAX_LEN		1024	//max string length. 512 bytes should be enough for everyone! Do you need more ?

const char* Strings_mF[]     = {"", "ΜΙΑ ", "", "ΤΡΕΙΣ ", "ΤΕΣΣΕΡΙΣ "};
const char* Strings_m[]      = {"", "ΕΝΑ ", "ΔΥΟ ", "ΤΡΙΑ ", "ΤΕΣΣΕΡΑ ", "ΠΕΝΤΕ ", "ΕΞΙ ", "ΕΠΤΑ ", "ΟΚΤΩ ", "ΕΝΝΕΑ "};
const char* Strings_dm[]     = {"ΔΕΚΑ ", "ΕΝΤΕΚΑ ", "ΔΩΔΕΚΑ "};      //Διαφοροποίησεις των 11,12 ως προς τα 13, 14, 15, ... 
const char* Strings_d[]      = {"", "ΔΕΚΑ", "ΕΙΚΟΣΙ ", "ΤΡΙΑΝΤΑ ", "ΣΑΡΑΝΤΑ ", "ΠΕΝΗΝΤΑ ", "ΕΞΗΝΤΑ ", "ΕΒΔΟΜΗΝΤΑ ", "ΟΓΔΟΝΤΑ ", "ΕΝΕΝΗΝΤΑ "};
const char* Strings_eF[]     = {"", "ΕΚΑΤΟ", "ΔΙΑΚΟΣΙΕΣ ", "ΤΡΙΑΚΟΣΙΕΣ ", "ΤΕΤΡΑΚΟΣΙΕΣ ", "ΠΕΝΤΑΚΟΣΙΕΣ ", "ΕΞΑΚΟΣΙΕΣ ", "ΕΠΤΑΚΟΣΙΕΣ ", "ΟΚΤΑΚΟΣΙΕΣ ", "ΕΝΝΙΑΚΟΣΙΕΣ "};
const char* Strings_em[]     = {"", "ΕΚΑΤΟ", "ΔΙΑΚΟΣΙΑ ", "ΤΡΙΑΚΟΣΙΑ ", "ΤΕΤΡΑΚΟΣΙΑ ", "ΠΕΝΤΑΚΟΣΙΑ ", "ΕΞΑΚΟΣΙΑ ", "ΕΠΤΑΚΟΣΙΑ ", "ΟΚΤΑΚΟΣΙΑ ", "ΕΝΝΙΑΚΟΣΙΑ "};
const char* Strings_idx[]    = {"ΛΕΠΤΑ", "ΕΥΡΩ", "ΧΙΛΙΑΔΕΣ ", "ΕΚΑΤΟΜΜΥΡΙ", "ΔΙΣ", "ΤΡΙΣ", "ΤΕΤΡΑ", "ΠΕΝΤΑ", "ΕΞΑ", "ΕΠΤΑ", "ΟΚΤΑ", "ΕΝΝΕΑ", "ΔΕΚΑ", "ΕΝΔΕΚΑ", "ΔΩΔΕΚΑ"};
const char* Strings_spc[]    = {"ΛΕΠΤΟ", "ΕΚΑΤΟ ", "ΕΚΑΤΟΝ ", "ΧΙΛΙΑ ", "ΚΙΣ "};
const char* Strings_prefix[] = {"MEION ", "ΜΗΔΕΝ ", " ΚΑΙ "};
const char* Strings_suffix[] = {"Ο ", "Α "};


double Round(double dVal, short iPrec)
{
	ULONGLONG power;

	if (iPrec == 0)
	{
		if(dVal < 0.0)
			return ceil(dVal - 0.5);
		else
			return floor(dVal + 0.5);
	}

	if (iPrec < 0)
	{
		power = POWERS[-iPrec];
		if(dVal < 0.0)
			return (double)(ceil(dVal / (double)power - 0.5) * (double)power);
		else
			return (double)(floor(dVal / (double)power + 0.5) * (double)power);
	}
	//iPrec > 0
	power = POWERS[iPrec];
	if(dVal < 0.0)
		return (double)(ceil(dVal * (double)power - 0.5) / (double)power);
	else
		return (double)(floor(dVal * (double)power + 0.5) / (double)power);
}

void GetValue(short money, short index, BOOL showCurrency, char* str)
{
    int dekmon;
	int monades;
	int ekatontades;
	int dekades;

    if (index == 2 && money == 1)
    {
        strcpy(str, Strings_spc[3]);
        return;
    }

    dekmon      = money % 100;
    monades     = dekmon % 10;
    ekatontades = (int)(money / 100);
    dekades     = (int)(dekmon / 10);

    (*str)='\0';

    //EKATONTADES
    if (money == 100)
    {
        strcpy(str, Strings_spc[1]);
    }
    else if (money >=200)
    {
        if (index == 2)
        {
            strcpy(str, Strings_eF[ekatontades]);
        }
        else
        {
            strcpy(str, Strings_em[ekatontades]);
        }
    }
    else if (money > 100)
    {
        strcpy(str, Strings_spc[2]);
    }

    //DEKADES
    switch (dekmon)
    {
    case 10:
    case 11:
    case 12:
        strcat(str, Strings_dm[monades]);
        monades = 0;
        break;
    default:
        strcat(str, Strings_d[dekades]);
        break;
    }
   
    //MONADES
    if (index == 2 && (monades == 1 || monades == 3 || monades == 4))
    {
        strcat(str, Strings_mF[monades]);
    }
    else
    {
        if (dekmon < 10 || dekmon > 12)
        {
            strcat(str, Strings_m[monades]);
        }
    }

    if ((*str) || index == 1)
    {
        if (index == 0 && money == 1)
        {
            if (showCurrency)
            {
                strcat(str, Strings_spc[0]);
            }
        }
        else
        {
            if (index > 1 || showCurrency)
            {
                strcat(str, Strings_idx[index]);
                if (index > 2)
                {
					if (index > 5)
					{
                        strcat(str, Strings_spc[4]);
					}
                    if (index > 3)
                    {
                        strcat(str, Strings_idx[3]);
                    }
                    if (money > 1)
                    {
						strcat(str, Strings_suffix[1]);
                    }
                    else
                    {
                        strcat(str, Strings_suffix[0]);
                    }
                }
            }
        }
    }
}


//void GetVerbal(char* outStr, double money, bool showZero /*= true*/, bool showCurrency /*= true*/)
void GetVerbal(char* outStr, double money, BOOL showZero, BOOL showCurrency)
{
	char tmpStr[MAX_LEN];
	char*	str;
	short	index		= 0;
	BOOL	isZero		= TRUE;
	BOOL	isNegative	= FALSE;
	double	money2;
	LONGLONG longMoney;

	str = tmpStr;

	(*outStr) = (*str) = '\0';

	if (money < 0)
	{
		money = -money;
		isNegative = TRUE;
	}

    //if (money != (LONGLONG)money)
    if (money != floor(money))
	{
		short value = (short)Round(100 * money - 100 * floor(money), 0);
		if (value >=100)
		{
			value -= 100;
			money += 1.0;
		}

		//money = (LONGLONG)money;
		money = floor(money);
		if (value > 0)
		{
			isZero = FALSE;

			if (money >= 1)
			{
				strcpy(str, Strings_prefix[2]);
			}
			GetValue( value, index, showCurrency, outStr);
			strcat(str, outStr);

			(*outStr) = '\0';
		}
	}

    while (money >= 1E+17)
	{
		short value;

		isZero = FALSE;
		money2 = floor(money / 1000);
		value = (short)(1000 * (money - money2));
#ifdef _DEBUG
		if (money < (money2*1000 + value))
			_asm int 3;
#endif
        money = money2;
        index += 1;
		if (index > 1 && value == 0)
			continue;

		GetValue(value, index, showCurrency, outStr);
        strcat(outStr, str);
		strcpy(str, outStr);

		(*outStr) = '\0';
	}

	longMoney = (LONGLONG)money;
	while (longMoney >= 1)
	{
		short value;

		isZero = FALSE;
		value = (short)(longMoney % 1000);
        longMoney /= 1000;
        index += 1;
		if (index > 1 && value == 0)
			continue;

		GetValue(value, index, showCurrency, outStr);
        strcat(outStr, str);
		strcpy(str, outStr);

		(*outStr) = '\0';
	}

	if (isZero)
	{
		if (showZero)
		{
			strcpy(outStr, Strings_prefix[1]);
			if (showCurrency)
				strcat(outStr, Strings_idx[1]);
		}
	}
	else
	{
		if (isNegative)
			strcpy(outStr, Strings_prefix[0]);
	}

	strcat(outStr, str);
}

char *internal_EuroValue_el(double money, BOOL showZero, BOOL showCurrency)
{
	char *pStr = emalloc(MAX_LEN);
	GetVerbal(pStr, money, showZero, showCurrency);

	return pStr;
}


static function_entry euroValue_functions[] = {
    PHP_FE(euroValue_version, NULL)
    PHP_FE(euroValue_UTF8_el, NULL)
#ifdef _WIN32
    PHP_FE(euroValue_ANSI_el, NULL)
#endif //_WIN32
    {NULL, NULL, NULL}
};


zend_module_entry euroValue_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
    STANDARD_MODULE_HEADER,
#endif
    PHP_EUROVALUE_WORLD_EXTNAME,
    euroValue_functions,
    NULL,
    NULL,
    NULL,
    NULL,
	PHP_MINFO(euroValue),	//    NULL,
#if ZEND_MODULE_API_NO >= 20010901
    PHP_EUROVALUE_WORLD_VERSION,
#endif
    STANDARD_MODULE_PROPERTIES
};


#ifdef COMPILE_DL_EUROVALUE
ZEND_GET_MODULE(euroValue)
#endif

PHP_MINFO_FUNCTION(euroValue)
{
	php_info_print_table_start();
	php_info_print_table_row(2, "euroValue Extension", "Show Currency values in Greek Verbal");
	php_info_print_table_row(2, "euroValue_UTF8_el", "Show values in UTF8");
#ifdef _WIN32
	php_info_print_table_row(2, "euroValue_ANSI_el", "Show values in ANSI");
#endif //_WIN32
	php_info_print_table_end();
}

PHP_FUNCTION(euroValue_version)
{
    RETURN_STRING(PHP_EUROVALUE_WORLD_VERSION, 1);
}


#ifdef _WIN32
PHP_FUNCTION(euroValue_UTF8_el)
{
	char *pStr;
	BOOL showZero = TRUE;
	BOOL showCurrency = TRUE;
	double money = 0.0;
	wchar_t UTF8Str[MAX_LEN];

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "d|bb", &money, &showZero, &showCurrency) == FAILURE) {
		RETURN_STRING("ΜΗ ΑΠΟΔΕΚΤΟΣ ΑΡΙΘΜΟΣ", 1);
    }

	pStr = internal_EuroValue_el(money, showZero, showCurrency);

	MultiByteToWideChar( CP_ACP, 0, pStr, -1, UTF8Str, MAX_LEN);
	WideCharToMultiByte(CP_UTF8, 0, UTF8Str, -1, pStr, MAX_LEN, NULL, NULL);
	
	RETURN_STRING(pStr, 0);
}
#endif //_WIN32

#ifdef _WIN32
PHP_FUNCTION(euroValue_ANSI_el)
#else //_WIN32
PHP_FUNCTION(euroValue_UTF8_el)
#endif //_WIN32
{
	BOOL showZero = TRUE;
	BOOL showCurrency = TRUE;
	double money = 0.0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "d|bb", &money, &showZero, &showCurrency) == FAILURE) {
		RETURN_STRING("ΜΗ ΑΠΟΔΕΚΤΟΣ ΑΡΙΘΜΟΣ", 1);
    }

	RETURN_STRING(internal_EuroValue_el(money, showZero, showCurrency), 0);
}

